
_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;Lcd.c,95 :: 		void main(){
;Lcd.c,97 :: 		DDRA = 0x00; //    
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, 0
	OUT        DDRA+0, R27
;Lcd.c,98 :: 		DDRD = 0xFF; //  ( )   
	LDI        R27, 255
	OUT        DDRD+0, R27
;Lcd.c,99 :: 		DDRE = 0xFF; // 
	LDI        R27, 255
	OUT        DDRE+0, R27
;Lcd.c,101 :: 		Lcd_Init();              // Initialize LCD
	CALL       _Lcd_Init+0
;Lcd.c,102 :: 		Lcd_Cmd(_LCD_CLEAR);     // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Lcd.c,103 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);// Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Lcd.c,104 :: 		Lcd_Out(1,1,"4*8 BIT LOGIC TESTER");
	LDI        R27, #lo_addr(?lstr1_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr1_Lcd+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,105 :: 		Lcd_Out(2,2,"Initialize data...");
	LDI        R27, #lo_addr(?lstr2_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr2_Lcd+0)
	MOV        R5, R27
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,108 :: 		for (k=0; k<=3; k++) random[k] = 0xFF;
	LDI        R27, 0
	STS        _k+0, R27
L_main0:
	LDS        R17, _k+0
	LDI        R16, 3
	CP         R16, R17
	BRSH       L__main39
	JMP        L_main1
L__main39:
	LDI        R17, #lo_addr(_random+0)
	LDI        R18, hi_addr(_random+0)
	LDS        R16, _k+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LDI        R27, 255
	ST         Z, R27
	LDS        R16, _k+0
	SUBI       R16, 255
	STS        _k+0, R16
	JMP        L_main0
L_main1:
;Lcd.c,109 :: 		for (k=0; k<=8; k++) {
	LDI        R27, 0
	STS        _k+0, R27
L_main3:
	LDS        R17, _k+0
	LDI        R16, 8
	CP         R16, R17
	BRSH       L__main40
	JMP        L_main4
L__main40:
;Lcd.c,110 :: 		j=0;
	LDI        R27, 0
	STS        _j+0, R27
;Lcd.c,111 :: 		while (j <= 3)  {
L_main6:
	LDS        R17, _j+0
	LDI        R16, 3
	CP         R16, R17
	BRSH       L__main41
	JMP        L_main7
L__main41:
;Lcd.c,112 :: 		PORTD = random[j];
	LDI        R17, #lo_addr(_random+0)
	LDI        R18, hi_addr(_random+0)
	LDS        R16, _j+0
	ADD        R17, R16
	LDI        R27, 0
	ADC        R18, R27
	MOV        R30, R17
	MOV        R31, R18
	LD         R16, Z
	OUT        PORTD+0, R16
;Lcd.c,113 :: 		random[j] = (random[j] >> 1);
	MOV        R30, R17
	MOV        R31, R18
	LD         R16, Z
	LSR        R16
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;Lcd.c,114 :: 		i = 0;
	LDI        R27, 0
	STS        _i+0, R27
;Lcd.c,115 :: 		while (i <= 2)  {
L_main8:
	LDS        R17, _i+0
	LDI        R16, 2
	CP         R16, R17
	BRSH       L__main42
	JMP        L_main9
L__main42:
;Lcd.c,116 :: 		PORTE = clk[j][i];
	LDI        R16, 3
	LDI        R17, 0
	LDS        R20, _j+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_clk+0)
	LDI        R19, hi_addr(_clk+0)
	ADD        R18, R16
	ADC        R19, R17
	LDS        R16, _i+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	OUT        PORTE+0, R16
;Lcd.c,117 :: 		i++;
	LDS        R16, _i+0
	SUBI       R16, 255
	STS        _i+0, R16
;Lcd.c,118 :: 		}
	JMP        L_main8
L_main9:
;Lcd.c,119 :: 		j++;
	LDS        R16, _j+0
	SUBI       R16, 255
	STS        _j+0, R16
;Lcd.c,120 :: 		}
	JMP        L_main6
L_main7:
;Lcd.c,121 :: 		Delay_ms(20);
	LDI        R18, 2
	LDI        R17, 4
	LDI        R16, 187
L_main10:
	DEC        R16
	BRNE       L_main10
	DEC        R17
	BRNE       L_main10
	DEC        R18
	BRNE       L_main10
	NOP
;Lcd.c,109 :: 		for (k=0; k<=8; k++) {
	LDS        R16, _k+0
	SUBI       R16, 255
	STS        _k+0, R16
;Lcd.c,122 :: 		}
	JMP        L_main3
L_main4:
;Lcd.c,123 :: 		Delay_ms(100);
	LDI        R18, 6
	LDI        R17, 19
	LDI        R16, 174
L_main12:
	DEC        R16
	BRNE       L_main12
	DEC        R17
	BRNE       L_main12
	DEC        R18
	BRNE       L_main12
	NOP
	NOP
;Lcd.c,124 :: 		Lcd_Out(2,2,"                    ");
	LDI        R27, #lo_addr(?lstr3_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr3_Lcd+0)
	MOV        R5, R27
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,125 :: 		Lcd_Out(4,1,"====(C) JA, 2011====");
	LDI        R27, #lo_addr(?lstr4_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr4_Lcd+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 4
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,126 :: 		Delay_ms(100);
	LDI        R18, 6
	LDI        R17, 19
	LDI        R16, 174
L_main14:
	DEC        R16
	BRNE       L_main14
	DEC        R17
	BRNE       L_main14
	DEC        R18
	BRNE       L_main14
	NOP
	NOP
;Lcd.c,127 :: 		Lcd_Cmd(_LCD_CLEAR);     // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Lcd.c,129 :: 		Lcd_Out(1,1,"Err1");
	LDI        R27, #lo_addr(?lstr5_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr5_Lcd+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,130 :: 		Lcd_Out(2,1,"Err2");
	LDI        R27, #lo_addr(?lstr6_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr6_Lcd+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,131 :: 		Lcd_Out(3,1,"Err3");
	LDI        R27, #lo_addr(?lstr7_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr7_Lcd+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 3
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,132 :: 		Lcd_Out(4,1,"Err4");
	LDI        R27, #lo_addr(?lstr8_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr8_Lcd+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 4
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,133 :: 		Lcd_Out(1,10,"Data:");
	LDI        R27, #lo_addr(?lstr9_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr9_Lcd+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,134 :: 		Lcd_Out(2,10,"Data:");
	LDI        R27, #lo_addr(?lstr10_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr10_Lcd+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,135 :: 		Lcd_Out(3,10,"Data:");
	LDI        R27, #lo_addr(?lstr11_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr11_Lcd+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 3
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,136 :: 		Lcd_Out(4,10,"Data:");
	LDI        R27, #lo_addr(?lstr12_Lcd+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr12_Lcd+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 4
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Lcd.c,138 :: 		for (i=0; i<=3; i++) flag[i] = 0; //  
	LDI        R27, 0
	STS        _i+0, R27
L_main16:
	LDS        R17, _i+0
	LDI        R16, 3
	CP         R16, R17
	BRSH       L__main43
	JMP        L_main17
L__main43:
	LDI        R17, #lo_addr(_flag+0)
	LDI        R18, hi_addr(_flag+0)
	LDS        R16, _i+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LDI        R27, 0
	ST         Z, R27
	LDS        R16, _i+0
	SUBI       R16, 255
	STS        _i+0, R16
	JMP        L_main16
L_main17:
;Lcd.c,140 :: 		for (k=0; k<=255; k++) {
	LDI        R27, 0
	STS        _k+0, R27
L_main19:
	LDS        R17, _k+0
	LDI        R16, 255
	CP         R16, R17
	BRSH       L__main44
	JMP        L_main20
L__main44:
;Lcd.c,141 :: 		PORTD = k; //    D    4 
	LDS        R16, _k+0
	OUT        PORTD+0, R16
;Lcd.c,142 :: 		for (j=0; j<=3; j++) {
	LDI        R27, 0
	STS        _j+0, R27
L_main22:
	LDS        R17, _j+0
	LDI        R16, 3
	CP         R16, R17
	BRSH       L__main45
	JMP        L_main23
L__main45:
;Lcd.c,143 :: 		for (i=0; i<=2; i++) PORTE = clk[j][i];
	LDI        R27, 0
	STS        _i+0, R27
L_main25:
	LDS        R17, _i+0
	LDI        R16, 2
	CP         R16, R17
	BRSH       L__main46
	JMP        L_main26
L__main46:
	LDI        R16, 3
	LDI        R17, 0
	LDS        R20, _j+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_clk+0)
	LDI        R19, hi_addr(_clk+0)
	ADD        R18, R16
	ADC        R19, R17
	LDS        R16, _i+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	OUT        PORTE+0, R16
	LDS        R16, _i+0
	SUBI       R16, 255
	STS        _i+0, R16
	JMP        L_main25
L_main26:
;Lcd.c,142 :: 		for (j=0; j<=3; j++) {
	LDS        R16, _j+0
	SUBI       R16, 255
	STS        _j+0, R16
;Lcd.c,144 :: 		}
	JMP        L_main22
L_main23:
;Lcd.c,145 :: 		for (m=0; m<=3; m++) { //  4   
	LDI        R27, 0
	STS        _m+0, R27
L_main28:
	LDS        R17, _m+0
	LDI        R16, 3
	CP         R16, R17
	BRSH       L__main47
	JMP        L_main29
L__main47:
;Lcd.c,146 :: 		switch (m) {
	JMP        L_main31
;Lcd.c,147 :: 		case 0: PORTE.B7 = 0; PORTE.B6 = 0; break;
L_main33:
	IN         R27, PORTE+0
	CBR        R27, 128
	OUT        PORTE+0, R27
	IN         R27, PORTE+0
	CBR        R27, 64
	OUT        PORTE+0, R27
	JMP        L_main32
;Lcd.c,148 :: 		case 1: PORTE.B7 = 0; PORTE.B6 = 1; break;
L_main34:
	IN         R27, PORTE+0
	CBR        R27, 128
	OUT        PORTE+0, R27
	IN         R27, PORTE+0
	SBR        R27, 64
	OUT        PORTE+0, R27
	JMP        L_main32
;Lcd.c,149 :: 		case 2: PORTE.B7 = 1; PORTE.B6 = 0; break;
L_main35:
	IN         R27, PORTE+0
	SBR        R27, 128
	OUT        PORTE+0, R27
	IN         R27, PORTE+0
	CBR        R27, 64
	OUT        PORTE+0, R27
	JMP        L_main32
;Lcd.c,150 :: 		case 3: PORTE.B7 = 1; PORTE.B6 = 1; break;
L_main36:
	IN         R27, PORTE+0
	SBR        R27, 128
	OUT        PORTE+0, R27
	IN         R27, PORTE+0
	SBR        R27, 64
	OUT        PORTE+0, R27
	JMP        L_main32
;Lcd.c,151 :: 		}
L_main31:
	LDS        R16, _m+0
	CPI        R16, 0
	BRNE       L__main48
	JMP        L_main33
L__main48:
	LDS        R16, _m+0
	CPI        R16, 1
	BRNE       L__main49
	JMP        L_main34
L__main49:
	LDS        R16, _m+0
	CPI        R16, 2
	BRNE       L__main50
	JMP        L_main35
L__main50:
	LDS        R16, _m+0
	CPI        R16, 3
	BRNE       L__main51
	JMP        L_main36
L__main51:
L_main32:
;Lcd.c,152 :: 		res = PINA; //  
	IN         R16, PINA+0
	STS        _res+0, R16
;Lcd.c,153 :: 		if (res != out[m][k]) flag[m]++;
	LDS        R16, _m+0
	MOV        R19, R16
	CLR        R18
	LDI        R16, #lo_addr(_out+0)
	LDI        R17, hi_addr(_out+0)
	ADD        R18, R16
	ADC        R19, R17
	LDS        R16, _k+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R18
	ADC        R31, R19
	LD         R17, Z
	LDS        R16, _res+0
	CP         R16, R17
	BRNE       L__main52
	JMP        L_main37
L__main52:
	LDI        R17, #lo_addr(_flag+0)
	LDI        R18, hi_addr(_flag+0)
	LDS        R16, _m+0
	ADD        R17, R16
	LDI        R27, 0
	ADC        R18, R27
	MOV        R30, R17
	MOV        R31, R18
	LD         R16, Z
	SUBI       R16, 255
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
L_main37:
;Lcd.c,154 :: 		ByteToStr(flag[m], buf);
	LDI        R17, #lo_addr(_flag+0)
	LDI        R18, hi_addr(_flag+0)
	LDS        R16, _m+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LD         R16, Z
	LDI        R27, #lo_addr(_buf+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_buf+0)
	MOV        R4, R27
	MOV        R2, R16
	CALL       _ByteToStr+0
;Lcd.c,155 :: 		Lcd_Out(m+1, 6, buf);
	LDS        R16, _m+0
	SUBI       R16, 255
	LDI        R27, #lo_addr(_buf+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_buf+0)
	MOV        R5, R27
	LDI        R27, 6
	MOV        R3, R27
	MOV        R2, R16
	CALL       _Lcd_Out+0
;Lcd.c,156 :: 		ByteToStr(res, buf);
	LDI        R27, #lo_addr(_buf+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_buf+0)
	MOV        R4, R27
	LDS        R2, _res+0
	CALL       _ByteToStr+0
;Lcd.c,157 :: 		Lcd_Out(m+1, 16, buf);
	LDS        R16, _m+0
	SUBI       R16, 255
	LDI        R27, #lo_addr(_buf+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_buf+0)
	MOV        R5, R27
	LDI        R27, 16
	MOV        R3, R27
	MOV        R2, R16
	CALL       _Lcd_Out+0
;Lcd.c,145 :: 		for (m=0; m<=3; m++) { //  4   
	LDS        R16, _m+0
	SUBI       R16, 255
	STS        _m+0, R16
;Lcd.c,158 :: 		}
	JMP        L_main28
L_main29:
;Lcd.c,140 :: 		for (k=0; k<=255; k++) {
	LDS        R16, _k+0
	SUBI       R16, 255
	STS        _k+0, R16
;Lcd.c,160 :: 		}
	JMP        L_main19
L_main20:
;Lcd.c,162 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
